SystemOrganization addCategory: #DirtyExperiments!

PluggableListMorph subclass: #OnTheFlySelectionPluggableListMorph
	instanceVariableNames: 'originalList keystrokeMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DirtyExperiments'!

!OnTheFlySelectionPluggableListMorph methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/18/2011 23:39'!
balloonMorphInstance

	^self hasKeyboardFocus
		ifTrue: [(SimpleBalloonMorphWithADeadLine
				string: self lastKeyStrokes
				for: self
				corner: #bottomLeft)
				timeToDeath: self defaultTimeToDeath]
		ifFalse:[
			SimpleBalloonMorph
				string: self lastKeyStrokes
				for: self
				corner: #bottomLeft]! !

!OnTheFlySelectionPluggableListMorph methodsFor: 'event handling' stamp: 'BenjaminVanRyseghem 1/18/2011 17:35'!
basicKeyPressed: aChar 

	self lastKeyStrokes: (self lastKeyStrokes, (aChar asString)).
	self updateAfterKeyStroke.
	^ self getCurrentSelectionIndex! !

!OnTheFlySelectionPluggableListMorph methodsFor: 'model access' stamp: 'BenjaminVanRyseghem 1/18/2011 17:27'!
changeModelSelection: anInteger
	"Change the model's selected item index to be anInteger."

	setIndexSelector ifNotNil:[ | currentElement index | 
		currentElement := list at: anInteger ifAbsent: [0].
		index := originalList indexOf: currentElement.
		model perform: setIndexSelector with: index].! !

!OnTheFlySelectionPluggableListMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/18/2011 22:24'!
checkIfTheMorphShouldBeDisplayed

	((self lastKeyStrokes isNil) or: [self lastKeyStrokes isEmpty])
		ifTrue: [self hideQueryMorph]
		ifFalse:[self showQueryMorph]! !

!OnTheFlySelectionPluggableListMorph methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/18/2011 23:13'!
defaultTimeToDeath

	^1500! !

!OnTheFlySelectionPluggableListMorph methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 1/18/2011 22:47'!
delete
	self halt.
	super delete.
	self keystrokeMorph delete! !

!OnTheFlySelectionPluggableListMorph methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 1/18/2011 22:54'!
displayKeyStrokeMorph

	"self privateAddMorph: self keystrokeMorph atIndex: (self submorphs size+1)."
	self keystrokeMorph openInWorld! !

!OnTheFlySelectionPluggableListMorph methodsFor: 'model access' stamp: 'BenjaminVanRyseghem 1/18/2011 17:32'!
getList
	"Answer the list to be displayed.  Caches the returned list in the 'list' ivar"
	| tempList |
	getListSelector == nil ifTrue: [^ #()].
	tempList := model perform: getListSelector.
	tempList ~= originalList
		ifTrue: [
			originalList := tempList.
			self resetLastKeyStrokes].
	originalList == nil ifTrue: [^ #()].
	tempList := originalList collect: [ :item | item asStringOrText ].
	((self lastKeyStrokes isNil) or: [self lastKeyStrokes isEmpty])
		ifTrue: [^list := tempList]
		ifFalse:[^list := tempList select: [:each | (each asLowercase) beginsWith: (self lastKeyStrokes asLowercase)]]! !

!OnTheFlySelectionPluggableListMorph methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/18/2011 23:27'!
hideQueryMorph

	(self hasKeyboardFocus not or: [self lastKeyStrokes isEmpty])
		ifTrue: [
			self keystrokeMorph ifNotNil: [:morph | morph delete]]! !

!OnTheFlySelectionPluggableListMorph methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/18/2011 22:22'!
initialize

	super initialize.
	self lastKeyStrokes: ''.! !

!OnTheFlySelectionPluggableListMorph methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/18/2011 23:11'!
initializeKeyStrokeMorph

	keystrokeMorph :=	self balloonMorphInstance.
	self displayKeyStrokeMorph.! !

!OnTheFlySelectionPluggableListMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/18/2011 15:42'!
keystrokeMorph

	^ keystrokeMorph! !

!OnTheFlySelectionPluggableListMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/18/2011 18:13'!
lastKeyStrokes
	lastKeystrokes ifNil: [lastKeystrokes := ''].
	^ lastKeystrokes! !

!OnTheFlySelectionPluggableListMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/18/2011 22:25'!
lastKeyStrokes: aString

	lastKeystrokes := aString.
	self changed: #lastKeystrokes.! !

!OnTheFlySelectionPluggableListMorph methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/18/2011 17:31'!
resetLastKeyStrokes

	self lastKeyStrokes: ''! !

!OnTheFlySelectionPluggableListMorph methodsFor: 'selection' stamp: 'BenjaminVanRyseghem 1/18/2011 23:46'!
selectionIndex: index
	"Called internally to select the index-th item."

	| row item idx |
	item := originalList at: index ifAbsent: [0].
	idx := list indexOf: item.
	self unhighlightSelection.
	row := idx ifNil: [ 0 ].
	row := row min: self maximumSelection.  "make sure we don't select past the end"
	self listMorph selectedRow: row.
	self highlightSelection.
	self scrollSelectionIntoView.! !

!OnTheFlySelectionPluggableListMorph methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 1/18/2011 22:37'!
showQueryMorph

	((self lastKeyStrokes isNil) or: [self lastKeyStrokes isEmpty])
		ifFalse: [self updateKeystrokeMorph]! !

!OnTheFlySelectionPluggableListMorph methodsFor: 'as yet unclassified ' stamp: 'BenjaminVanRyseghem 1/18/2011 15:26'!
specialKeyPressed: asciiValue
	"A special key with the given ascii-value was pressed; dispatch it"

	| oldSelection nextSelection max howManyItemsShowing |

	asciiValue = 8 
		ifTrue: [ "backspace"
			((lastKeystrokes isNil) or: [lastKeystrokes isEmpty])
				ifTrue: [^self].
			lastKeystrokes := lastKeystrokes allButLast.
			self updateAfterKeyStroke].
		
	asciiValue = 27 ifTrue: 
		[" escape key"
		^ ActiveEvent shiftPressed
			ifTrue:
				[ActiveWorld invokeWorldMenuFromEscapeKey]
			ifFalse:
				[self yellowButtonActivity: false]].

	max := self maximumSelection.
	max > 0 ifFalse: [^ self].
	nextSelection := oldSelection := self getCurrentSelectionIndex.
	asciiValue = 31 ifTrue: 
		[" down arrow"
		nextSelection := oldSelection + 1.
		nextSelection > max ifTrue: [nextSelection := max]].
	asciiValue = 30 ifTrue: 
		[" up arrow"
		nextSelection := oldSelection - 1.
		nextSelection < 1 ifTrue: [nextSelection := 1]].
	asciiValue = 1 ifTrue:
		[" home"
		nextSelection := 1].
	asciiValue = 4 ifTrue:
		[" end"
		nextSelection := max].
	howManyItemsShowing := self numSelectionsInView.
	asciiValue = 11 ifTrue:
		[" page up"
		nextSelection := 1 max: oldSelection - howManyItemsShowing].
	asciiValue = 12 ifTrue:
		[" page down"
		nextSelection := oldSelection + howManyItemsShowing min: max].
	(self enabled and: [model okToChange]) ifFalse: [^ self].
	"No change if model is locked"
	oldSelection = nextSelection ifTrue: [^ self flash].
	^ self changeModelSelection: nextSelection! !

!OnTheFlySelectionPluggableListMorph methodsFor: 'event handling' stamp: 'BenjaminVanRyseghem 1/18/2011 22:53'!
step

	self hasFocus
		ifTrue: [self showQueryMorph]
		ifFalse:[self hideQueryMorph]! !

!OnTheFlySelectionPluggableListMorph methodsFor: 'stepping' stamp: 'BenjaminVanRyseghem 1/18/2011 22:35'!
stepTime

	^100! !

!OnTheFlySelectionPluggableListMorph methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/18/2011 22:25'!
updateAfterKeyStroke

	self changed: #lastKeyStrokes.
	self changeModelSelection: 0.
	self checkIfTheMorphShouldBeDisplayed.
	self updateList! !

!OnTheFlySelectionPluggableListMorph methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/18/2011 22:26'!
updateKeystrokeMorph

	self keystrokeMorph
		ifNotNil: [:morph | morph delete].
	self initializeKeyStrokeMorph.! !

Object subclass: #DummyTest
	instanceVariableNames: 'list selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DirtyExperiments'!

!DummyTest classSide methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 1/18/2011 15:16'!
on: aList

	^ self new list: aList! !

!DummyTest methodsFor: 'adding' stamp: 'BenjaminVanRyseghem 1/18/2011 15:15'!
addAll: aWindow

	aWindow
		addMorph: self buildAutoSelectionList
		frame: ((0.25@0) corner: (0.75@1))! !

!DummyTest methodsFor: 'building' stamp: 'BenjaminVanRyseghem 1/18/2011 17:22'!
buildAutoSelectionList

	^ OnTheFlySelectionPluggableListMorph
			on: self 
			list: #list 
			selected: #selection 
			changeSelected: #selection:! !

!DummyTest methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/18/2011 15:12'!
list

	^list! !

!DummyTest methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/18/2011 15:12'!
list: aList

	list := aList! !

!DummyTest methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 1/18/2011 15:13'!
openInWorld


	| window |
	window := StandardWindow new.
	self addAll: window.
	window openInWorld.
	window title: 'Dummy Example'! !

!DummyTest methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/18/2011 15:20'!
selection
	
	selection ifNil: [selection := 0].
	^selection! !

!DummyTest methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/18/2011 15:34'!
selection: aSelection

	selection := aSelection.
	self changed: #selection! !

SimpleBalloonMorph subclass: #SimpleBalloonMorphWithADeadLine
	instanceVariableNames: 'secondPass timeToDeath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DirtyExperiments'!

!SimpleBalloonMorphWithADeadLine classSide methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 1/18/2011 22:57'!
timeToDeath: anInteger

	^ self new timeToDeath: anInteger! !

!SimpleBalloonMorphWithADeadLine methodsFor: 'initialize-release' stamp: 'BenjaminVanRyseghem 1/18/2011 23:05'!
initialize

	secondPass := false.
	super initialize.
	self stopStepping.! !

!SimpleBalloonMorphWithADeadLine methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/18/2011 23:03'!
openInWorld

	super openInWorld.
	self startStepping! !

!SimpleBalloonMorphWithADeadLine methodsFor: 'stepping and presenter' stamp: 'BenjaminVanRyseghem 1/18/2011 23:22'!
step

	secondPass ifTrue: [self delete].
	secondPass := true! !

!SimpleBalloonMorphWithADeadLine methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 1/18/2011 22:57'!
stepTime

	^ self timeToDeath! !

!SimpleBalloonMorphWithADeadLine methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/18/2011 23:29'!
timeToDeath

	^timeToDeath ifNil: [0]! !

!SimpleBalloonMorphWithADeadLine methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/18/2011 22:56'!
timeToDeath: anInteger

	timeToDeath := anInteger.
	self startStepping! !
